import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:rothko_mobile/model/states_lga_model.dart';

class RothkoCache {
  static GlobalKey<NavigatorState>? navigatorKey;
  static StatesAndLgaResponse? statesAndLgaResponse;
  static States? selectedState = States(localGovernments: []);

  static initialize(ThemeMode Function(BuildContext context) getThemeModeI,
      Function() toggleTheme) {
    navigatorKey = new GlobalKey<NavigatorState>();
    getTheme = getThemeModeI;
    toggle = toggleTheme;

    fetchStates();
  }

  static void setNavKey(GlobalKey<NavigatorState> navKey) {
    navigatorKey = navKey;
  }

  static ThemeMode Function(BuildContext context)? getTheme;

  static void Function()? toggle;

  static Future fetchStates() async {
    statesAndLgaResponse = await RothoService.fetchStates();
    return statesAndLgaResponse;
  }
}

class RothoService {
  static Future<StatesAndLgaResponse> fetchStates() async {
    return StatesAndLgaResponse.fromJson(
        jsonDecode(await rootBundle.loadString('assets/states_lga.json')));
  }
}
